Bug 1010137 (CVE-2013-4351)

Summary: CVE-2013-4351 gnupg: treats no-usage-permitted keys as all-usages-permitted
Product: [Other] Security Response Reporter: Ratul Gupta <ratulg>
Component: vulnerabilityAssignee: Red Hat Product Security <security-response-team>
Status: CLOSED ERRATA QA Contact:
Severity: low Docs Contact:
Priority: low    
Version: unspecifiedCC: bcl, btotty, huzaifas, jamielinux, jjaburek, jkurik, rdieter, slukasik, tmraz
Target Milestone: ---Keywords: Security
Target Release: ---   
Hardware: All   
OS: Linux   
Whiteboard: impact=low,public=20130312,reported=20130920,source=suse,cvss2=2.6/AV:N/AC:H/Au:N/C:N/I:P/A:N,rhel-5/gnupg=affected,rhel-5/gnupg2=affected,rhel-6/gnupg2=affected,rhel-7/gnupg2=notaffected,fedora-all/gnupg=affected,fedora-all/gnupg2=affected,epel-5/gnupg2=affected
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2015-08-22 02:26:37 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
Bug Depends On: 1010140, 1010141, 1010142, 1015736, 1015737, 1015738, 1015739, 1015740, 1015741, 1015743, 1018109, 1018110    
Bug Blocks: 1010144, 1015687    

Description Ratul Gupta 2013-09-20 01:20:21 EDT
GnuPG and GnuPG2 are found to have a flaw, where the key flags are misinterpreted, which could possibly lead to a breach of confidentiality or a mistaken identity verification. Key flags are the packets, that indicated the capabilities of the key, represented as binary flags. The issue is that if a key or subkey has this "key flags" subpacket attached with all bits cleared (off), GnuPG currently treats the key as having all bits set (on), though the thing to note is that the keys with this sort of marker are very rare in the wild.
The risks are unlikely today, and they are not particularly dangerous, but the keyholder's stated intent of separating out keys by context of use is being ignored, so there is a window of vulnerability that should not be open.

References:
http://seclists.org/oss-sec/2013/q3/599
https://bugs.gentoo.org/show_bug.cgi?id=484836
https://bugzilla.novell.com/show_bug.cgi?id=840510
Comment 1 Ratul Gupta 2013-09-20 01:28:41 EDT
Patches are available, but appear to only be applied on the development
branch (2.1.x).  So stable branches 1.4.x and 2.0.x remain vulnerable at
the moment.
Comment 2 Ratul Gupta 2013-09-20 01:31:39 EDT
Created gnupg2 tracking bugs for this issue:

Affects: fedora-all [bug 1010141]
Affects: epel-5 [bug 1010142]
Comment 3 Ratul Gupta 2013-09-20 01:31:57 EDT
Created gnupg tracking bugs for this issue:

Affects: fedora-all [bug 1010140]
Comment 4 Fedora Update System 2013-10-10 10:47:56 EDT
gnupg-1.4.15-1.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 8 Fedora Update System 2013-10-11 20:02:46 EDT
gnupg-1.4.15-1.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.
Comment 13 errata-xmlrpc 2013-10-24 11:25:02 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 5
  Red Hat Enterprise Linux 6

Via RHSA-2013:1459 https://rhn.redhat.com/errata/RHSA-2013-1459.html
Comment 14 errata-xmlrpc 2013-10-24 11:27:08 EDT
This issue has been addressed in following products:

  Red Hat Enterprise Linux 5

Via RHSA-2013:1458 https://rhn.redhat.com/errata/RHSA-2013-1458.html
Comment 15 Fedora Update System 2013-11-12 21:26:12 EST
gnupg-1.4.15-1.fc18 has been pushed to the Fedora 18 stable repository.  If problems still persist, please make note of it in this bug report.